---
title: <input type="date">
slug: Web/HTML/Element/input/date
tags:
  - Date
  - Date picker
  - Element
  - Form Inputs
  - HTML
  - HTML forms
  - Input
  - Input Element
  - Input Type
  - Reference
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">{{HTMLElement("input")}} elements of <strong><code>type="date"</code></strong> create input fields that let the user enter a date, either with a textbox that validates the input or a special date picker interface.</span></p>

<p>The resulting value includes the year, month, and day, but <em>not</em> the time. The {{HTMLElement("input/time", "time")}} and {{HTMLElement("input/datetime-local", "datetime-local")}} input types support time and date+time input.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/input-date.html", "tabbed-shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The input UI generally varies from browser to browser; see {{anch("Browser compatibility")}} for further details. In unsupported browsers, the control degrades gracefully to <code><a href="/en-US/docs/Web/HTML/Element/input/text">&lt;input type="text"&gt;</a></code>.</p>

<p>Among browsers with custom interfaces for selecting dates are Chrome, Edge, and Opera, whose date control looks like so:</p>

<p><img alt="Chrome's date input as of November 2020" src="chrome-date-input.png" style="display: block; margin: 0 auto;"></p>

<p>And the Firefox date control looks like this:</p>

<p><img alt="Another “dd/mm/yyyy” textbox that expands into a selectable calendar control." src="firefox_datepicker.png" style="display: block; margin: 0 auto;"></p>

<table class="properties">
 <tbody>
  <tr>
   <td><strong>{{anch("Value")}}</strong></td>
   <td>A {{domxref("DOMString")}} representing a date in YYYY-MM-DD format, or empty</td>
  </tr>
  <tr>
   <td><strong>Events</strong></td>
   <td>{{domxref("HTMLElement/change_event", "change")}} and {{domxref("HTMLElement/input_event", "input")}}</td>
  </tr>
  <tr>
   <td><strong>Supported common attributes</strong></td>
   <td>{{htmlattrxref("autocomplete", "input")}}, {{htmlattrxref("list", "input")}}, {{htmlattrxref("readonly", "input")}}, and {{htmlattrxref("step", "input")}}</td>
  </tr>
  <tr>
   <td><strong>IDL attributes</strong></td>
   <td><code>list</code>, <code>value</code>, <code>valueAsDate</code>, <code>valueAsNumber</code>.</td>
  </tr>
  <tr>
   <td><strong>Methods</strong></td>
   <td>{{domxref("HTMLInputElement.select", "select()")}}, {{domxref("HTMLInputElement.stepDown", "stepDown()")}}, {{domxref("HTMLInputElement.stepUp", "stepUp()")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Value">Value</h2>

<p>A {{domxref("DOMString")}} representing the date entered in the input. The date is formatted according to ISO8601, described in {{SectionOnPage("/en-US/docs/Web/HTML/Date_and_time_formats", "Format of a valid date string")}}.</p>

<p>You can set a default value for the input with a date inside the {{htmlattrxref("value", "input")}} attribute, like so:</p>

<pre class="brush: html notranslate">&lt;input type="date" value="2017-06-01"&gt;</pre>

<p>{{EmbedLiveSample('Value', 600, 40)}}</p>

<div class="notecard note">
<p><strong>The displayed date format will differ from the actual <code>value</code></strong> — the displayed date is formatted <em>based on the locale of the user's browser</em>, but the parsed <code>value</code> is always formatted <code>yyyy-mm-dd</code>.</p>
</div>

<p>You can get and set the date value in JavaScript with the input element's {{domxref("HTMLInputElement.value", "value")}} and {{domxref("HTMLInputElement.valueAsNumber", "valueAsNumber")}} properties. For example:</p>

<pre class="brush: js notranslate">var dateControl = document.querySelector('input[type="date"]');
dateControl.value = '2017-06-01';
console.log(dateControl.value); // prints "2017-06-01"
console.log(dateControl.valueAsNumber); // prints 1496275200000, a JavaScript timestamp (ms)</pre>

<p>This code finds the first {{HTMLElement("input")}} element whose <code>type</code> is <code>date</code>, and sets its value to <code>2017-06-01</code> (June 1<sup>st</sup>, 2017). It then reads that value back in string and number formats.</p>

<h2 id="Additional_attributes">Additional attributes</h2>

<p>Along with the attributes common to all {{HTMLElement("input")}} elements, <code>date</code> inputs have the following attributes:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>{{anch("max")}}</code></td>
   <td>The latest acceptable date</td>
  </tr>
  <tr>
   <td><code>{{anch("min")}}</code></td>
   <td>The earliest acceptable date</td>
  </tr>
  <tr>
   <td><code>{{anch("step")}}</code></td>
   <td>The <em>stepping interval</em>, when clicking up and down spinner buttons and validating the date</td>
  </tr>
 </tbody>
</table>

<h3 id="htmlattrdefmax">{{htmlattrdef("max")}}</h3>

<p>The latest date to accept. If the {{htmlattrxref("value", "input")}} entered into the element occurs afterward, the element fails <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">constraint validation</a>. If the value of the <code>max</code> attribute isn't a possible date string in the format <code>yyyy-mm-dd</code>, then the element has no maximum date value.</p>

<p>If both the <code>max</code> and <code>min</code> attributes are set, this value must be a date string <strong>later than or equal to</strong> the one in the <code>min</code> attribute.</p>

<h3 id="htmlattrdefmin">{{htmlattrdef("min")}}</h3>

<p>The earliest date to accept. If the {{htmlattrxref("value", "input")}} entered into the element occurs beforehand, the element fails <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">constraint validation</a>. If the value of the <code>min</code> attribute isn't a possible date string in the format <code>yyyy-mm-dd</code>, then the element has no minimum date value.</p>

<p>If both the <code>max</code> and <code>min</code> attributes are set, this value must be a date string <strong>earlier than or equal to</strong> the one in the <code>max</code> attribute.</p>

<h3 id="htmlattrdefstep">{{htmlattrdef("step")}}</h3>

<p>{{page("/en-US/docs/Web/HTML/Element/input/number", "step-include")}}</p>

<p>For <code>date</code> inputs, the value of <code>step</code> is given in days; and is treated as a number of milliseconds equal to 86,400,000 times the <code>step</code> value (the underlying numeric value is in milliseconds). The default value of <code>step</code> is 1, indicating 1 day.</p>

<div class="notecard note">
<p>Specifying <code>any</code> as the value for <code>step</code> has the same effect as <code>1</code> for <code>date</code> inputs.</p>
</div>

<h2 id="Using_date_inputs">Using date inputs</h2>

<p>Date inputs sound convenient — they provide an easy interface for choosing dates, and they normalize the data format sent to the server regardless of the user's locale. However, there are currently issues with <code>&lt;input type="date"&gt;</code> because of its limited browser support.</p>

<p>In this section, we'll look at basic and then more complex uses of <code>&lt;input type="date"&gt;</code>, and offer advice on mitigating the browser support issue later (see {{anch("Handling browser support")}}).</p>

<div class="notecard note">
<p>Hopefully, over time browser support will become ubiquitous, and this problem will fade away.</p>
</div>

<h3 id="Basic_uses_of_date">Basic uses of date</h3>

<p>The simplest use of <code>&lt;input type="date"&gt;</code> involves one <code>&lt;input&gt;</code> combined with its {{htmlelement("label")}}, as seen below:</p>

<pre class="brush: html notranslate">&lt;form action="https://example.com"&gt;
  &lt;label&gt;
    Enter your birthday:
    &lt;input type="date" name="bday"&gt;
  &lt;/label&gt;

  &lt;p&gt;&lt;button&gt;Submit&lt;/button&gt;&lt;/p&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Basic_uses_of_date', 600, 40)}}</p>

<p>This HTML submits the entered date under the key <code>bday</code> to <code>https://example.com</code> — resulting in a URL like <code>https://example.com/?bday=1955-06-08</code>.</p>

<h3 id="Setting_maximum_and_minimum_dates">Setting maximum and minimum dates</h3>

<p>You can use the {{htmlattrxref("min", "input")}} and {{htmlattrxref("max", "input")}} attributes to restrict the dates that can be chosen by the user. In the following example, we set a minimum date of <code>2017-04-01</code> and a maximum date of <code>2017-04-30</code>:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="party"&gt;Choose your preferred party date:
    &lt;input type="date" name="party" min="2017-04-01" max="2017-04-30"&gt;
  &lt;/label&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Setting_maximum_and_minimum_dates', 600, 40)}}</p>

<p>The result is that only days in April 2017 can be selected — the month and year parts of the textbox will be uneditable, and dates outside April 2017 can't be selected in tte picker widget.</p>

<div class="note">
<p><strong>Note</strong>: You <em>should</em> be able to use the {{htmlattrxref("step", "input")}} attribute to vary the number of days jumped each time the date is incremented (e.g. to only make Saturdays selectable). However, this does not seem to be in any implementation at the time of writing.</p>
</div>

<h3 id="Controlling_input_size">Controlling input size</h3>

<p><code>&lt;input type="date"&gt;</code> doesn't support form sizing attributes such as {{htmlattrxref("size", "input")}}. Prefer <a href="/en-US/docs/Web/CSS">CSS</a> for sizing it.</p>

<h2 id="Validation">Validation</h2>

<p>By default, <code>&lt;input type="date"&gt;</code> doesn't validate the entered value beyond its format. The interfaces generally don't let you enter anything that isn't a date — which is helpful — but you can leave the field empty or enter an invalid date in browsers where the input falls back to type <code>text</code> (like the 32nd of April).</p>

<p>If you use {{htmlattrxref("min", "input")}} and {{htmlattrxref("max", "input")}} to restrict the available dates (see {{anch("Setting maximum and minimum dates")}}), supporting browsers will display an error if you try to submit a date that is out of bounds. However, you'll need to double-check the submitted results to ensure the value is within these dates, if the date picker isn't fully supported on the user's device.</p>

<p>You can also use the {{htmlattrxref("required", "input")}} attribute to make filling in the date mandatory — an error will be displayed if you try to submit an empty date field. This should work in most browsers, even if they fall back to a text input.</p>

<p>Let's look at an example of minimum and maximum dates, and also made a field required:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label&gt;
    Choose your preferred party date (required, April 1st to 20th):
    &lt;input type="date" name="party" min="2017-04-01" max="2017-04-20" required&gt;
    &lt;span class="validity"&gt;&lt;/span&gt;
  &lt;/label&gt;

  &lt;p&gt;
    &lt;button&gt;Submit&lt;/button&gt;
  &lt;/p&gt;
&lt;/form&gt;</pre>

<p>If you try to submit the form with an incomplete date (or with a date outside the set bounds), the browser displays an error. Try playing with the example now:</p>

<p>{{EmbedLiveSample('Validation', 600, 100)}}</p>

<p>Here's a screenshot for those of you who aren't using a supporting browser:</p>

<p><img alt="The input field has an overlaid speech balloon, with an orange exclamation mark icon and the message “Please fill in this field.”" src="date-picker-chrome-error-message.png" style="border-style: solid; border-width: 1px; display: block; margin: 0px auto;"></p>

<p>Here's the CSS used in the above example. We make use of the {{cssxref(":valid")}} and {{cssxref(":invalid")}} <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-elements</a> to add an icon next to the input, based on whether or not the current value is valid. We had to put the icon on a {{htmlelement("span")}} next to the input, not on the input itself, because in Chrome at least the input's generated content is placed inside the form control, and can't be styled or shown effectively.</p>

<pre class="brush: css notranslate">label {
  display: flex;
  align-items: center;
}

span::after {
  padding-left: 5px;
}

input:invalid + span::after {
  content: '✖';
}

input:valid+span::after {
  content: '✓';
}</pre>

<div class="warning">
<p><strong>Important</strong>: Client-side form validation <em>is no substitute</em> for validating on the server. It's easy for someone to modify the HTML, or bypass your HTML entirely and submit the data directly to your server. If your server fails to validate the received data, disaster could strike with data that is badly-formatted, too large, of the wrong type, etc.</p>
</div>

<h2 id="Handling_browser_support">Handling browser support</h2>

<p>As mentioned, the major problem with date inputs at the time of writing is {{anch("Browser compatibility", "browser support")}}. As an example, the date picker on Firefox for Android looks like this:</p>

<p><img alt="A popup calendar picker modal floats above the web page and browser UI." src="date-picker-fxa.png" style="display: block; margin: 0 auto;"></p>

<p>Unsupporting browsers gracefully degrade to a text input, but this creates problems in consistency of user interface (the presented controls are different) and data handling.</p>

<p>The second problem is the more serious one; with date input supported, the value is normalized to the format <code>yyyy-mm-dd</code>. But with a text input, the browser has no recognition of what format the date should be in, and there are many different formats in which people write dates. For example:</p>

<ul>
 <li><code>ddmmyyyy</code></li>
 <li><code>dd/mm/yyyy</code></li>
 <li><code>mm/dd/yyyy</code></li>
 <li><code>dd-mm-yyyy</code></li>
 <li><code>mm-dd-yyyy</code></li>
 <li><code>Month dd, yyyy</code></li>
</ul>

<p>One way around this is the {{htmlattrxref("pattern", "input")}} attribute on your date input. Even though the date picker doesn't use it, the text input fallback will. For example, try viewing the following in a unsupporting browser:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="bday"&gt;Enter your birthday:
    &lt;input type="date" name="bday" required pattern="\d{4}-\d{2}-\d{2}"&gt;
    &lt;span class="validity"&gt;&lt;/span&gt;
  &lt;/label&gt;
  &lt;p&gt;
    &lt;button&gt;Submit&lt;/button&gt;
  &lt;/p&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Handling_browser_support', 600, 100)}}</p>

<p>If you submit it, you'll see that the browser displays an error and highlights the input as invalid if your entry doesn't match the pattern <code>####-##-##</code> (where <code>#</code> is a digit from 0 to 9). Of course, this doesn't stop people from entering invalid dates, or incorrect formats. So we still have a problem.</p>

<div class="hidden">
<pre class="brush: css notranslate">span {
  position: relative;
}

span::after {
  right: -18px;
  position: absolute;
}

input:invalid + span::after {
  content: '✖';
}

input:valid + span::after {
  content: '✓';
}</pre>
</div>

<p>At the moment, the best way to deal with dates in forms in a cross-browser way is to have the user enter the day, month, and year in separate controls, or to use a JavaScript library such as <a href="https://jqueryui.com/datepicker/">jQuery date picker</a>.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, we create 2 sets of UI elements for choosing dates: a native <code>&lt;input type="date"&gt;</code> picker and a set of 3 {{htmlelement("select")}} elements for older browsers that don't support the native date input.</p>

<p>{{EmbedLiveSample('Examples', 600, 100)}}</p>

<h3 id="HTML">HTML</h3>

<p>The HTML looks like so:</p>

<pre class="brush: html notranslate">&lt;form&gt;
    &lt;div class="nativeDatePicker"&gt;
      &lt;label for="bday"&gt;Enter your birthday:&lt;/label&gt;
      &lt;input type="date" id="bday" name="bday"&gt;
      &lt;span class="validity"&gt;&lt;/span&gt;
    &lt;/div&gt;
    &lt;p class="fallbackLabel"&gt;Enter your birthday:&lt;/p&gt;
    &lt;div class="fallbackDatePicker"&gt;
      &lt;span&gt;
        &lt;label for="day"&gt;Day:&lt;/label&gt;
        &lt;select id="day" name="day"&gt;
        &lt;/select&gt;
      &lt;/span&gt;
      &lt;span&gt;
        &lt;label for="month"&gt;Month:&lt;/label&gt;
        &lt;select id="month" name="month"&gt;
          &lt;option selected&gt;January&lt;/option&gt;
          &lt;option&gt;February&lt;/option&gt;
          &lt;option&gt;March&lt;/option&gt;
          &lt;option&gt;April&lt;/option&gt;
          &lt;option&gt;May&lt;/option&gt;
          &lt;option&gt;June&lt;/option&gt;
          &lt;option&gt;July&lt;/option&gt;
          &lt;option&gt;August&lt;/option&gt;
          &lt;option&gt;September&lt;/option&gt;
          &lt;option&gt;October&lt;/option&gt;
          &lt;option&gt;November&lt;/option&gt;
          &lt;option&gt;December&lt;/option&gt;
        &lt;/select&gt;
      &lt;/span&gt;
      &lt;span&gt;
        &lt;label for="year"&gt;Year:&lt;/label&gt;
        &lt;select id="year" name="year"&gt;
        &lt;/select&gt;
      &lt;/span&gt;
    &lt;/div&gt;
&lt;/form&gt;</pre>

<p>The months are hardcoded (as they are always the same), while the day and year values are dynamically generated depending on the currently selected month and year, and the current year (see the code comments below for detailed explanations of how these functions work.)</p>

<div class="hidden">
<pre class="brush: css notranslate">span {
  padding-left: 5px;
}

input:invalid + span::after {
  content: '✖';
}

input:valid + span::after {
  content: '✓';
}</pre>
</div>

<h3 id="JavaScript">JavaScript</h3>

<p>The other part of the code that may be of interest is the feature detection code — to detect whether the browser supports <code>&lt;input type="date"&gt;</code>.</p>

<p>We create a new {{htmlelement("input")}} element, try setting its <code>type</code> to <code>date</code>, then immediately check what its type is — unsupporting browsers will return <code>text</code>, because the <code>date</code> type falls back to type <code>text</code>. If <code>&lt;input type="date"&gt;</code> isn't supported, we hide the native picker and show the fallback ({{htmlelement("select")}}) instead.</p>

<pre class="brush: js notranslate">// define variables
var nativePicker = document.querySelector('.nativeDatePicker');
var fallbackPicker = document.querySelector('.fallbackDatePicker');
var fallbackLabel = document.querySelector('.fallbackLabel');

var yearSelect = document.querySelector('#year');
var monthSelect = document.querySelector('#month');
var daySelect = document.querySelector('#day');

// hide fallback initially
fallbackPicker.style.display = 'none';
fallbackLabel.style.display = 'none';

// test whether a new date input falls back to a text input or not
var test = document.createElement('input');

try {
  test.type = 'date';
} catch (e) {
  console.log(e.description);
}

// if it does, run the code inside the if() {} block
if(test.type === 'text') {
  // hide the native picker and show the fallback
  nativePicker.style.display = 'none';
  fallbackPicker.style.display = 'block';
  fallbackLabel.style.display = 'block';

  // populate the days and years dynamically
  // (the months are always the same, therefore hardcoded)
  populateDays(monthSelect.value);
  populateYears();
}

function populateDays(month) {
  // delete the current set of &lt;option&gt; elements out of the
  // day &lt;select&gt;, ready for the next set to be injected
  while(daySelect.firstChild){
    daySelect.removeChild(daySelect.firstChild);
  }

  // Create variable to hold new number of days to inject
  var dayNum;

  // 31 or 30 days?
  if(month === 'January' | month === 'March' | month === 'May' | month === 'July' | month === 'August' | month === 'October' | month === 'December') {
    dayNum = 31;
  } else if(month === 'April' | month === 'June' | month === 'September' | month === 'November') {
    dayNum = 30;
  } else {
  // If month is February, calculate whether it is a leap year or not
  var year = yearSelect.value;
  var isLeap = new Date(year, 1, 29).getMonth() == 1;
  isLeap ? dayNum = 29 : dayNum = 28;
  }

  // inject the right number of new &lt;option&gt; elements into the day &lt;select&gt;
  for(i = 1; i &lt;= dayNum; i++) {
    var option = document.createElement('option');
    option.textContent = i;
    daySelect.appendChild(option);
  }

  // if previous day has already been set, set daySelect's value
  // to that day, to avoid the day jumping back to 1 when you
  // change the year
  if(previousDay) {
    daySelect.value = previousDay;

    // If the previous day was set to a high number, say 31, and then
    // you chose a month with less total days in it (e.g. February),
    // this part of the code ensures that the highest day available
    // is selected, rather than showing a blank daySelect
    if(daySelect.value === "") {
      daySelect.value = previousDay - 1;
    }

    if(daySelect.value === "") {
      daySelect.value = previousDay - 2;
    }

    if(daySelect.value === "") {
      daySelect.value = previousDay - 3;
    }
  }
}

function populateYears() {
  // get this year as a number
  var date = new Date();
  var year = date.getFullYear();

  // Make this year, and the 100 years before it available in the year &lt;select&gt;
  for(var i = 0; i &lt;= 100; i++) {
    var option = document.createElement('option');
    option.textContent = year-i;
    yearSelect.appendChild(option);
  }
}

// when the month or year &lt;select&gt; values are changed, rerun populateDays()
// in case the change affected the number of available days
yearSelect.onchange = function() {
  populateDays(monthSelect.value);
}

monthSelect.onchange = function() {
  populateDays(monthSelect.value);
}

//preserve day selection
var previousDay;

// update what day has been set to previously
// see end of populateDays() for usage
daySelect.onchange = function() {
  previousDay = daySelect.value;
}</pre>

<div class="note">
<p><strong>Note</strong>: Remember that some years have 53 weeks in them (see <a href="https://en.wikipedia.org/wiki/ISO_week_date#Weeks_per_year">Weeks per year</a>)! You'll need to take this into consideration when developing production apps.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comments</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#date-state-(type=date)', '&lt;input type="date"&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'sec-forms.html#date-state-typedate', '&lt;input type="date"&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("html.elements.input.input-date")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The generic {{HTMLElement("input")}} element and the interface used to manipulate it, {{domxref("HTMLInputElement")}}</li>
 <li><a href="/en-US/docs/Learn/Forms/Basic_native_form_controls#Date_and_time_picker">Date and Time picker tutorial</a></li>
 <li><a href="/en-US/docs/Web/HTML/Date_and_time_formats">Date and time formats used in HTML</a></li>
 <li><a href="/en-US/docs/Learn/Forms/Property_compatibility_table_for_form_controls">Compatibility of CSS properties</a></li>
</ul>
